import java.util.*;
import java.io.*; 
public class histograma
{
// se realiza un funcion dentro de la clase de Contar la que usa para
// los tres casos (Con o Sin archivos de Entrada)
    public static void Contar(InputStream origen, OutputStream destino)
    {
	InputStreamReader  org     = new InputStreamReader (origen );
	OutputStreamWriter dest    = new OutputStreamWriter(destino);
	Hashtable words = new Hashtable();
	int c = ' ';
	try 
	    { // Cambie el try parce mas logico
		while (c >= 0)
		    {
			StringBuffer w = new StringBuffer();
			do
			    {
				c = org.read();
// Todos los UpperCase han sido cambiados por LowerCase
// y Vice-versa para obtener el listado en Mayusculas
				if (Character.isLowerCase((char)c))
				    c = Character.toUpperCase((char)c);
				if (Character.isUpperCase((char)c))
				    w.append((char)c);
				else
				    break;
			    }
			while (true);
			if (w.length() > 0)
			    {
				String s = w.toString();
				if (words.containsKey(s))
				    {
					Integer cnt = (Integer)words.get(s);
					words.put(s, new Integer(cnt.intValue()+1));
				    }
				else
				    {
					words.put(s, new Integer(1));
				    }
			    }
		    }
	    }
	catch (java.io.IOException e) {c = -1; System.out.println("FIN..."); }
	Vector concord = new Vector();
	for (Enumeration e = words.keys(); e.hasMoreElements();)
	    {
		String w = (String)e.nextElement();
		Integer cnt = (Integer)words.get(w);
		concord.add (new WordCounts(w, cnt.intValue()));
	    }
	for (int i = 1; i < concord.size(); ++i)
	    {
		WordCounts element = (WordCounts)concord.get(i);
		int j = i - 1;
		while ((j >= 0) && (element.compareTo((WordCounts)concord.get(j)) < 0))
		    {
			concord.set(j+1, concord.get(j));
			j--;
		    }
		concord.set(j+1, element);
	    }
	try
	    {
		dest.write ("\n" + '\n'+ '\t' + "# de Veces" +  '\t' + " Palabra\n" + '\n');
		for (int j = 0; j < concord.size(); j++)
		    {
			WordCounts wc = (WordCounts)concord.get(j);
			
			dest.write ('\t' + "     " + wc.count +  '\t' + '\t' + "   " + wc.word + '\n');
		    }
		dest.flush();
		
	    }
	catch( IOException e )
	    {	
		System.err.println("Problema de E/S");
		System.err.println(e.getMessage());
		System.exit(1);
	    }
    }
    
    public static void main(String args[])
    {
// Para cada caso de parametro se obtiene lo siguiente
// parametro = 0 => Implica Entrada Teclado y Salida Pantalla
// parametro = 1 => Implica Entrada de Archivo y salida Pantalla
// parametro = 2 => Implica Entrada Archivo y Salida Archivo
// parametro > 2 => Implica Error en entrada de parametros
// Para cada caso se llama a Contar la que hace el Algoritmo completo
// Llamando a WordCounts

	int parametro = args.length;
	try
	    {
		if (parametro == 0)
		    {
			System.out.println("\n\n\tEscriba un Texto al cual desee contar" );
			System.out.println("\tlas veces que se repiten las palabras \n");	
			System.out.println("\n\tPara Terminar Presione Ctrl + D \n");	
			Contar (System.in, System.out);
			System.out.println("\n\tPrograma ha sido realizado exitosamente" + '\n');
		    }
		if (parametro == 1)
		    {
			FileInputStream    origen  = new FileInputStream   (args[0]);
			Contar (origen, System.out);  
			System.out.println("\n\tSe ha Contado Exitosamente el Archivo \"" + args[0] +"\""+ +'\n');
		    }
		if (parametro == 2)
		    {
			FileInputStream    origen  = new FileInputStream   (args[0]);
			FileOutputStream   destino = new FileOutputStream  (args[1]);
			Contar (origen, destino);  
			System.out.println("\n\tSe ha Contado Exitosamente el Archivo \"" + args[0] +"\"");
			System.out.println("\n\tLos resultados se encuentran en el Archivo \"" + args[1] +"\""+ '\n');	       
		    }
		if (parametro > 2)
		    {
			System.out.println( "\n\tParametros Ingresados no Validos");
		    } 
	    }

// El Catch es en el caso de que no se pueda abrir el Archivo o que exista un error de
// entrada  y salida. Este atrapa el error y muestra en pantalla el Error

	catch ( FileNotFoundException e )
	    {  System.err.println("\n ERROR: No se encuentra el archivo \"" + args[0] +"\"" + '\n');
	    //                System.err.println(e.getMessage());
	    System.exit(1);
	    }
	
    }
};
